### Daniel Hopkins
### April 25, 2011
###
### Hispanic precincts in 1998 California June primary
### Analyses for "Translating into Votes"

setwd("C:/Users/dh335/Documents/CA")

library(lme4)
library(arm)

load("hispanicpcts042511.Rdata")

#### save Stata version
library(foreign)
write.dta(cleandata2,file="hispanicpcts042511.dta")

#### rescale numeric threshold variable

cleandata2$NUMLIMENGR <- cleandata2$NUMLIMENG/10000

##+I(NUMLIMENGR^3)
mlm.his.227.turn <- lmer(TURNOUT227 ~ TOTREG + DEMPCT + REPPCT + HISPPCT 
+KORPCT + JPNPCT + CHIPCT + AGE1824 + AGE2534 +AGE3544 + AGE4554 + AGE65PL +
PCHIS00 + PCNHBL00 + PCNHWH00 + PCNHNA00 + PCNHAS00 +LGMEHOVAL00 + PCIMM00 + 
AVCOMMUTE00 + PCTOWN00 +LGMHINC00 + PCPA00 + PCSS00 + PCBCH00 +PCSHO00 + PCSCO00 + 
POPDNS00 +DEM94PCT + REP94PCT + HISPPCT94+TREATED*CTLIMENGSP+PCIMM00+
PCTLIMENG+I(PCTLIMENG^2)+I(PCTLIMENG^3)+I(NUMLIMENGR^2)+NUMLIMENGR+
CTLIMENGSP+CTLIMENGAS+COdempct96+(1|COUNTY), data=cleandata2)
display(mlm.his.turn.227)
summary(mlm.his.turn.227)

#### coefficients figure

mlm.his.227 <- lmer(PR227PCT~ TOTREG + DEMPCT + REPPCT + HISPPCT 
+KORPCT + JPNPCT + CHIPCT + AGE1824 + AGE2534 +AGE3544 + AGE4554 + AGE65PL +
PCHIS00 + PCNHBL00 + PCNHWH00 + PCNHNA00 + PCNHAS00 +LGMEHOVAL00 + PCIMM00 + 
AVCOMMUTE00 + PCTOWN00 +LGMHINC00 + PCPA00 + PCSS00 + PCBCH00 +PCSHO00 + PCSCO00 + 
POPDNS00 +DEM94PCT + REP94PCT + HISPPCT94+TREATED*CTLIMENGSP+PCIMM00+
PCTLIMENG+I(PCTLIMENG^2)+I(PCTLIMENG^3)+I(NUMLIMENG^2)+I(NUMLIMENG^2)+NUMLIMENG+
CTLIMENGSP+CTLIMENGAS+COdempct96+(1|COUNTY), data=cleandata2)
display(mlm.his.227)

beta <- fixef(mlm.his.227)
se <- se.coef(mlm.his.227)$fixef

COEF <- cbind(beta,se)

rn22 <- c("Intercept","Registrants","Dem Pct R","Rep Pct R","Hispanic Pct R",
"Korean Pct R","Japanese Pct R","Chinese Pct R","Pct 18-24 R","Pct 25-34 R",
"Pct 35-44 R","Pct 45-54 R","Pct Over 64 R","Pct Hispanic T","Pct Black T",
"Pct White T","Pct Native Am T","Pct Asian T","Med Home Value","Pct Immig T",
"Avg Commute T","Pct Homeowner T","Med Income T","Pct Welfare T","Pct Soc Security T",
"Pct with BA T","Pct Same House T","Pct Same County T","Pop Density",
"Pct Dem 94 R","Pct Rep 94 R","Pct Hispanic 94 R","Section 203","Pct Span/Limited Eng T",
"Pct LEP C","Pct LEP Sq C",
"Pct LEP Cubed C","Num LEP Sq C","Number LEP",
"Pct EA/Limited Eng T","Pct Democrat C","Section 203 x Limited English")

cbind(rownames(COEF),rn22)

COEF2 <- COEF
COEF2[rownames(COEF2)=="NUMLIMENG",] <- COEF[rownames(COEF2)=="NUMLIMENG",]*10^4
COEF2[rownames(COEF2)=="I(NUMLIMENG^2)",] <- COEF[rownames(COEF2)=="I(NUMLIMENG^2)",]*10^9
COEF2[rownames(COEF2)=="I(PCTLIMENG^3)",] <- COEF[rownames(COEF2)=="I(PCTLIMENG^3)",]/10^4
COEF2[rownames(COEF2)=="PCTLIMENG",] <- COEF[rownames(COEF2)=="PCTLIMENG",]/10^2
COEF2[rownames(COEF2)=="I(PCTLIMENG^2)",] <- COEF[rownames(COEF2)=="I(PCTLIMENG^2)",]/10^3
COEF2[rownames(COEF2)=="POPDNS00",] <- COEF[rownames(COEF2)=="POPDNS00",]/10^2

MX <- COEF2[,1]+1.96*COEF2[,2]
MN <- COEF2[,1]-1.96*COEF2[,2]
which(MX==max(MX))
which(MN==min(MN))
COEF2A <- COEF2[order(COEF2[,1]),]
rn23 <- rn22[order(COEF2[,1])]

rn <- rownames(COEF2A)
idx <- which(rn %in% c("NUMLIMENG","TREATED:CTLIMENGSP","COdempct96","TREATED","I(NUMLIMENG^2)","I(PCTLIMENG^3)","PCTLIMENG","I(PCTLIMENG^2)","I(PCTLIMENG^2)"))
col2 <- rep("black",dim(COEF2A)[1])
col2[idx] <- "red"

#pdf("C:/Users/dh335/Documents/CA/latinoprecincts227C.pdf")
#postscript("C:/Users/dh335/Documents/CA/latinoprecincts227C.eps")
plot(y=1:dim(COEF2A)[1],x=COEF2A[,1],yaxt="n",xlim=c(min(MN),max(MX)+.15),pch=16,main="Latino Precincts: Vote For 227",ylab="",xlab="Coefficient",col=col2,cex.main=2,cex.lab=1.5)
for(i in 1:dim(COEF2A)[1]){
	if(i %in% idx){
		lines(y=c(i,i),x=c(COEF2A[i,1]-1.96*COEF2A[i,2],COEF2A[i,1]+1.96*COEF2A[i,2]),col="red")
		text(rn23[i],y=i,x=.45,cex=.95,col="red")
	}
	if(! i %in% idx & COEF2A[i,1] < 0){
		lines(y=c(i,i),x=c(COEF2A[i,1]-1.96*COEF2A[i,2],COEF2A[i,1]+1.96*COEF2A[i,2]))
		text(rn23[i],y=i,x=.7,cex=.85,col="black")
	}
	if(! i %in% idx & COEF2A[i,1] > 0){
		lines(y=c(i,i),x=c(COEF2A[i,1]-1.96*COEF2A[i,2],COEF2A[i,1]+1.96*COEF2A[i,2]))
		text(rn23[i],y=i,x=-.7,cex=.85,col="black")
	}
}
abline(v=0)
#dev.off()




#### predicted impact figure
#### figure 
mlm.his.227.extract <- lm(TURNOUT227 ~ TOTREG + DEMPCT + REPPCT + HISPPCT 
+KORPCT + JPNPCT + CHIPCT + AGE1824 + AGE2534 +AGE3544 + AGE4554 + AGE65PL +
PCHIS00 + PCNHBL00 + PCNHWH00 + PCNHNA00 + PCNHAS00 +LGMEHOVAL00 + PCIMM00 + 
AVCOMMUTE00 + PCTOWN00 +LGMHINC00 + PCPA00 + PCSS00 + PCBCH00 +PCSHO00 + PCSCO00 + 
POPDNS00 +DEM94PCT + REP94PCT + HISPPCT94+TREATED*CTLIMENGSP+PCIMM00+
PCTLIMENG+I(PCTLIMENG^2)+I(PCTLIMENG^3)+I(NUMLIMENGR^2)+NUMLIMENGR+
CTLIMENGSP+CTLIMENGAS+COdempct96, data=cleandata2)

mf <- model.frame(mlm.his.227.extract)
mfvec <- apply(mf,2,median)
mfvec[which(names(mfvec)=="NUMLIMENGR")] <- 23110/10000
mfvec[which(names(mfvec)=="I(NUMLIMENGR^2)")] <- (23110/10000)^2
mfvec[1] <- 1
names(mfvec)[1] <- "(Intercept)"

ql <- quantile(cleandata2$PCTLIMENG,0)
qh <- quantile(cleandata2$PCTLIMENG,1)

ssp <- seq(from=ql,to=qh,length=100)

pct.threshold <- .105
num.threshold <- 2.07

rmat <- matrix(NA,length(ssp),6)
#### vary county-level percentages
for(i in 1:length(ssp)){
	pct <- ssp[i]
	mfvec[which(names(mfvec)=="PCTLIMENG")] <-  pct
	mfvec[which(names(mfvec)=="I(PCTLIMENG^2)")] <- (pct^2)
	mfvec[which(names(mfvec)=="I(PCTLIMENG^3)")] <- (pct^3)
	mf.med.c.s <- mf.med.c.e <- mfvec

	qlt <- quantile(cleandata2$CTLIMENGSP,.05)
	qht <- quantile(cleandata2$CTLIMENGSP,.95)

	mf.med.c.s[which(names(mf.med.c.s)=="CTLIMENGSP")] <- qht
	mf.med.c.e[which(names(mf.med.c.e)=="CTLIMENGSP")] <- qlt
	
	mf.med.c.s[which(names(mf.med.c.s)=="TREATED")] <- (pct > pct.threshold)*1
	mf.med.c.e[which(names(mf.med.c.e)=="TREATED")] <- (pct > pct.threshold)*1
	if(pct < pct.threshold){
		mf.c.s <- c(mf.med.c.s,0)
		mf.c.e <- c(mf.med.c.e,0)
	}else{
		mf.c.s <- c(mf.med.c.s,1*qht)
		mf.c.e <- c(mf.med.c.e,1*qlt)
	}
	COEF <- sim(mlm.his.227.turn,n.sims=100000)
	pcs.draws <- COEF$fixef%*%c(mf.c.s)
	pce.draws <- COEF$fixef%*%c(mf.c.e)

	rmat[i,1] <- median(pcs.draws)
	rmat[i,2] <- quantile(pcs.draws,.025)
	rmat[i,3] <- quantile(pcs.draws,.975)

	rmat[i,4] <- median(pce.draws)
	rmat[i,5] <- quantile(pce.draws,.025)
	rmat[i,6] <- quantile(pce.draws,.975)
}


#### vary county-level numbers

mf <- model.frame(mlm.his.227.extract)
mfvec <- apply(mf,2,median)
mfvec[1] <- 1
names(mfvec)[1] <- "(Intercept)"

ql <- quantile(cleandata2$NUMLIMENGR,.05)
qh <- quantile(cleandata2$NUMLIMENGR,.95)

ssn <- seq(from=ql,to=qh,length=100)

rmat2 <- matrix(NA,length(ssn),6)
#### vary county-level numbers
for(i in 1:length(ssn)){
	num <- ssn[i]
	mfvec[which(names(mfvec)=="NUMLIMENGR")] <- ssn[i]
	mfvec[which(names(mfvec)=="I(NUMLIMENGR^2)")] <- ssn[i]^2

	pct <- median(cleandata2$PCTLIMENG)
	mfvec[which(names(mfvec)=="PCTLIMENG")] <-  pct
	mfvec[which(names(mfvec)=="I(PCTLIMENG^2)")] <- (pct^2)
	mfvec[which(names(mfvec)=="I(PCTLIMENG^3)")] <- (pct^3)
	mf.med.c.s <- mf.med.c.e <- mfvec
	qlt <- quantile(cleandata2$CTLIMENGSP,.05)
	qht <- quantile(cleandata2$CTLIMENGSP,.95)
	mf.med.c.s[which(names(mf.med.c.s)=="CTLIMENGSP")] <- qht
	mf.med.c.e[which(names(mf.med.c.e)=="CTLIMENGSP")] <- qlt
	mf.med.c.s[which(names(mf.med.c.s)=="TREATED")] <- (num > num.threshold)*1
	mf.med.c.e[which(names(mf.med.c.e)=="TREATED")] <- (num > num.threshold)*1
	if(num < num.threshold){
		mf.c.s <- c(mf.med.c.s,0)
		mf.c.e <- c(mf.med.c.e,0)
	}else{
		mf.c.s <- c(mf.med.c.s,1*qht)
		mf.c.e <- c(mf.med.c.e,1*qlt)
	}
	COEF <- sim(mlm.his.227.turn,n.sims=100000)
	pcs.draws <- COEF$fixef%*%c(mf.c.s)
	pce.draws <- COEF$fixef%*%c(mf.c.e)
	rmat2[i,1] <- median(pcs.draws)
	rmat2[i,2] <- quantile(pcs.draws,.025)
	rmat2[i,3] <- quantile(pcs.draws,.975)
	rmat2[i,4] <- median(pce.draws)
	rmat2[i,5] <- quantile(pce.draws,.025)
	rmat2[i,6] <- quantile(pce.draws,.975)
}




#postscript("onetreatturn080310.eps",height=6,width=6)
#pdf("onetreatturn072110.pdf")
par(mfcol=c(1,2))
par(pty="s")
#ymn <- .1
#ymx <- .6

ymn <- .15
ymx <- .5

md <- median(cleandata2$CTLIMENGSP,na.rm=T)
rn <- rnorm(length(cleandata2$CTLIMENGSP[cleandata2$CTLIMENGSP > md & cleandata2$TREATED==0]),mean=0,sd=0.001)
plot(cleandata2$PCTLIMENG[cleandata2$CTLIMENGSP > md & cleandata2$TREATED==0]+rn,cleandata2$TURNOUT227[cleandata2$CTLIMENGSP > md & cleandata2$TREATED==0],ylim=c(ymn,ymx),xlim=c(0,.15),main="",pch=10,cex=.2,col="grey",xlab="",ylab="")
abline(v=pct.threshold,col="blue",lty=2)
par(new=T)
rn <- rnorm(length(cleandata2$CTLIMENGSP[cleandata2$CTLIMENGSP > md & cleandata2$TREATED==1]),mean=0,sd=0.001)
plot(cleandata2$PCTLIMENG[cleandata2$CTLIMENGSP > md & cleandata2$TREATED==1]+rn,cleandata2$TURNOUT227[cleandata2$CTLIMENGSP > md & cleandata2$TREATED==1],ylim=c(ymn,ymx),xlim=c(0,.15),main="",pch=18,cex=.2,col="black",xlab="",ylab="")
par(new=T)
plot(ssp,rmat[,1],ylim=c(ymn,ymx),main="Many Spanish \n Speakers",col="red",xlim=c(0,.15),pch=16,cex.main=1.6,xlab="Co. Percent Limited Eng.",ylab="Turnout",cex.lab=1.5,cex=.5)


md <- median(cleandata2$CTLIMENGSP,na.rm=T)
rn <- rnorm(length(cleandata2$CTLIMENGSP[cleandata2$CTLIMENGSP < md & cleandata2$TREATED==0]),mean=0,sd=0.001)
plot(cleandata2$PCTLIMENG[cleandata2$CTLIMENGSP < md & cleandata2$TREATED==0]+rn,cleandata2$TURNOUT227[cleandata2$CTLIMENGSP < md & cleandata2$TREATED==0],ylim=c(ymn,ymx),xlim=c(0,.15),main="",pch=10,cex=.2,col="grey",xlab="",ylab="")
abline(v=pct.threshold,col="blue",lty=2)
par(new=T)
rn <- rnorm(length(cleandata2$CTLIMENGSP[cleandata2$CTLIMENGSP < md & cleandata2$TREATED==1]),mean=0,sd=0.001)
plot(cleandata2$PCTLIMENG[cleandata2$CTLIMENGSP < md & cleandata2$TREATED==1]+rn,cleandata2$TURNOUT227[cleandata2$CTLIMENGSP < md & cleandata2$TREATED==1],ylim=c(ymn,ymx),xlim=c(0,.15),main="",pch=18,cex=.2,col="black",xlab="",ylab="")
par(new=T)
plot(ssp,rmat[,4],ylim=c(ymn,ymx),main="Few Spanish \n Speakers",col="red",xlim=c(0,.15),pch=16,cex.main=1.6,xlab="Co. Percent Limited Eng.",ylab="Turnout",cex.lab=1.5,cex=.5)
dev.off()



#postscript("onetreat227num080310b.eps",height=7,width=7)
#pdf("onetreat227num080310.pdf")
par(mfcol=c(1,2))
par(pty="s")
ymn <- .15
ymx <- .5
#ymx <- .75

md <- median(cleandata2$CTLIMENGSP,na.rm=T)
rn <- rnorm(length(cleandata2$CTLIMENGSP[cleandata2$CTLIMENGSP > md & cleandata2$TREATED==0]),mean=0,sd=0.02)
plot(cleandata2$NUMLIMENGR[cleandata2$CTLIMENGSP > md & cleandata2$TREATED==0]+rn,cleandata2$PR227PCT[cleandata2$CTLIMENGSP > md & cleandata2$TREATED==0],ylim=c(ymn,ymx),xlim=c(0,4),main="",pch=10,cex=.2,col="grey",xlab="",ylab="")
abline(v=num.threshold,col="blue",lty=2)
par(new=T)
rn <- rnorm(length(cleandata2$CTLIMENGSP[cleandata2$CTLIMENGSP > md & cleandata2$TREATED==1]),mean=0,sd=0.02)
plot(cleandata2$NUMLIMENGR[cleandata2$CTLIMENGSP > md & cleandata2$TREATED==1]+rn,cleandata2$TURNOUT227[cleandata2$CTLIMENGSP > md & cleandata2$TREATED==1],ylim=c(ymn,ymx),xlim=c(0,4),main="",pch=18,cex=.2,col="black",xlab="",ylab="")
par(new=T)
plot(ssn,rmat2[,1],ylim=c(ymn,ymx),main="Many Spanish \n Speakers",col="red",xlim=c(0,4),pch=16,cex.main=1.6,xlab="Co. Number Limited Eng.",ylab="Turnout",cex.lab=1.5,cex=.5)


md <- median(cleandata2$CTLIMENGSP,na.rm=T)
rn <- rnorm(length(cleandata2$CTLIMENGSP[cleandata2$CTLIMENGSP < md & cleandata2$TREATED==0]),mean=0,sd=0.02)
plot(cleandata2$NUMLIMENGR[cleandata2$CTLIMENGSP < md & cleandata2$TREATED==0]+rn,cleandata2$TURNOUT227[cleandata2$CTLIMENGSP < md & cleandata2$TREATED==0],ylim=c(ymn,ymx),xlim=c(0,4),main="",pch=10,cex=.2,col="grey",xlab="",ylab="")
abline(v=num.threshold,col="blue",lty=2)
par(new=T)
rn <- rnorm(length(cleandata2$CTLIMENGSP[cleandata2$CTLIMENGSP < md & cleandata2$TREATED==1]),mean=0,sd=0.02)
plot(cleandata2$NUMLIMENGR[cleandata2$CTLIMENGSP < md & cleandata2$TREATED==1]+rn,cleandata2$PR227PCT[cleandata2$CTLIMENGSP < md & cleandata2$TREATED==1],ylim=c(ymn,ymx),xlim=c(0,4),main="",pch=18,cex=.2,col="black",xlab="",ylab="")
par(new=T)
plot(ssn,rmat2[,4],ylim=c(ymn,ymx),main="Few Spanish \n Speakers",col="red",xlim=c(0,4),pch=16,cex.main=1.6,xlab="Co. Number Limited Eng.",ylab="Turnout",cex.lab=1.5,cex=.5)
dev.off()

####

####### estimated effects

num <- 2.07
pct <- .105
mlm.his.227.extract <- lm(TURNOUT227 ~ TOTREG + DEMPCT + REPPCT + HISPPCT 
+KORPCT + JPNPCT + CHIPCT + AGE1824 + AGE2534 +AGE3544 + AGE4554 + AGE65PL +
PCHIS00 + PCNHBL00 + PCNHWH00 + PCNHNA00 + PCNHAS00 +LGMEHOVAL00 + PCIMM00 + 
AVCOMMUTE00 + PCTOWN00 +LGMHINC00 + PCPA00 + PCSS00 + PCBCH00 +PCSHO00 + PCSCO00 + 
POPDNS00 +DEM94PCT + REP94PCT + HISPPCT94+TREATED*CTLIMENGSP+PCIMM00+
PCTLIMENG+I(PCTLIMENG^2)+I(PCTLIMENG^3)+I(NUMLIMENGR^2)+NUMLIMENGR+
CTLIMENGSP+CTLIMENGAS+COdempct96, data=cleandata2)

mf <- model.frame(mlm.his.227.extract)

mfvec[which(names(mfvec)=="NUMLIMENGR")] <- num
mfvec[which(names(mfvec)=="I(NUMLIMENGR^2)")] <- num^2
mfvec[which(names(mfvec)=="PCTLIMENG")] <-  pct
mfvec[which(names(mfvec)=="I(PCTLIMENG^2)")] <- (pct^2)
mfvec[which(names(mfvec)=="I(PCTLIMENG^3)")] <- (pct^3)
mf.med.c.s <- mf.med.c.e <- mfvec

qlt <- quantile(cleandata2$CTLIMENGSP,.05)
qht <- quantile(cleandata2$CTLIMENGSP,.95)
mf.med.c.s[which(names(mf.med.c.s)=="CTLIMENGSP")] <- qht
mf.med.c.e[which(names(mf.med.c.e)=="CTLIMENGSP")] <- qlt

### under
mf.med.c.s[which(names(mf.med.c.s)=="TREATED")] <- 0
mf.med.c.e[which(names(mf.med.c.e)=="TREATED")] <- 0
mf.c.s <- c(mf.med.c.s,0)
mf.c.e <- c(mf.med.c.e,0)
COEF <- sim(mlm.his.227.turn,n.sims=100000)
pcs.draws.u <- COEF$fixef%*%c(mf.c.s)
pce.draws.u <- COEF$fixef%*%c(mf.c.e)

### over
mf.med.c.s[which(names(mf.med.c.s)=="TREATED")] <- 1
mf.med.c.e[which(names(mf.med.c.e)=="TREATED")] <- 1
mf.c.s <- c(mf.med.c.s,1*qht)
mf.c.e <- c(mf.med.c.e,1*qlt)
COEF <- sim(mlm.his.227.turn,n.sims=100000)
pcs.draws.o <- COEF$fixef%*%c(mf.c.s)
pce.draws.o <- COEF$fixef%*%c(mf.c.e)

quantile(pcs.draws.o-pcs.draws.u-(pce.draws.o-pce.draws.u),.025)	
quantile(pcs.draws.o-pcs.draws.u-(pce.draws.o-pce.draws.u),.975)
mean(pcs.draws.o-pcs.draws.u-(pce.draws.o-pce.draws.u))
1-sum(pcs.draws.o-pcs.draws.u-(pce.draws.o-pce.draws.u)>0)/100000




#### subsetting out neighborhoods with many Spanish speakers
cleandata3 <- cleandata2[cleandata2$CTLIMENGSP > quantile(cleandata2$CTLIMENGSP,.7),]

mlm.his.227.sub <- lmer(PR227PCT ~ TOTREG + DEMPCT + REPPCT + HISPPCT 
+KORPCT + JPNPCT + CHIPCT + AGE1824 + AGE2534 +AGE3544 + AGE4554 + AGE65PL +
PCHIS00 + PCNHBL00 + PCNHWH00 + PCNHNA00 + PCNHAS00 +LGMEHOVAL00 + PCIMM00 + 
AVCOMMUTE00 + PCTOWN00 +LGMHINC00 + PCPA00 + PCSS00 + PCBCH00 +PCSHO00 + PCSCO00 + 
POPDNS00 +DEM94PCT + REP94PCT + HISPPCT94+TREATED+CTLIMENGSP+PCIMM00+
PCTLIMENG+I(PCTLIMENG^2)+I(PCTLIMENG^3)+I(NUMLIMENG^2)+I(NUMLIMENG^2)+NUMLIMENG+
CTLIMENGSP+CTLIMENGAS+(1|COUNTY), data=cleandata3)
#display(mlm.his.227.sub)
summary(mlm.his.227.sub)
